/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on May 23, 2013
 *
 */

package mbtest.test.guards;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;
import mbtest.tracing.Logger;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class Test1
{
  static Logger logger = new Logger(Test1.class);
  
  int x = 0;
  int y = 0;
  int NX = 15;
  int NY = 15;
  
  @State
  public int getX() { return x; }

  @State
  public int getY() { return y; }
  
  @Test
  @DataProvider(name="data")
  @Guard(names={"object.check","stateguard","fieldguard", "cond.in.condition"})
  public void forward(int p) { /*if(x < NX && (y == 0 || y == NY))*/ x = (x+p)%NX; }

  //@Test
  //public void backward() { if(x > 0 && y == 0) x--; }

  @Test(dependsOnMethods={"forward"}/*,"backward"}*/)
  public void up() { /*if(y < NY)*/ y = (y+1)%NY; }
  
  //@Test(dependsOnMethods={"forward","backward"})
  //public void down() { if(y > 0) y--; }
  
  /*@Test
  public void step(int i, int j)
  {
    x = (x+i)%NX;
    y = (y+j)%NY;
  }*/
  
  int[] data = new int[]{1, 2};
  
  boolean stateguard() { return x != NX-1 && y != 0; }
  boolean fieldguard = true;
  
  Inner object = new Inner();
  Inner2 cond = new Inner2(this);
  
  class Inner 
  {
    public boolean check() 
    { 
      logger.logDebug("check called");
      
      return Test1.this.x != 18 || Test1.this.y != 1;
    }
  }
  
  static class Inner1
  {
    Test1 t;
    Inner1(Test1 t) { this.t = t;}
    public boolean getCondition() 
    { 
      logger.logDebug("condition called");
      return t.x < 35 && t.y < 36;
    }
  }
  
  static class Inner2
  {
    Inner1 in;
    Inner2(Test1 t) { in = new Inner1(t);}
  }

}
