/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 04.10.2009
 *
 */

package mbtest.tests.account;

import mbtest.contracts.Contract;
import mbtest.tracing.Logger;

/**
 * @author Victor Kuliamin
 *
 */
public class AccountContract
{
  static Logger logger = new Logger(AccountContract.class);
  
  int balance;
  int maxCredit;
  
  Account checkedObject;
  
  public void setCheckedObject(Account checkedObject)
  {
    this.checkedObject = checkedObject;
    this.balance       = checkedObject.getBalance();
    this.maxCredit     = checkedObject.getMaxCredit();
  }

  public boolean possibleTransfer(int sum)
  {
    if(balance + sum > maxCredit) return true;
    else                          return false;
  }
  
  public boolean transferPost(int sum)
  {
    //logger.logInfo("checkedObject = " + checkedObject);
    //logger.logInfo("balance UT    = " + checkedObject.getBalance());
    //logger.logInfo("balance       = " + balance);
    //logger.logInfo("permitter     = " + checkedObject.getPermitter());
    boolean permission = checkedObject.getPermitter().isPermittedTransfer(checkedObject, sum);

    if (Contract.oldBooleanValue(possibleTransfer(sum)) && permission)
      return    Contract.assertEquals(Contract.intResult(), sum                                
                  , "Result should be equal to the argument")
             && Contract.assertEquals(balance, Contract.oldIntValue(balance) + sum
                  , "Balance should be increased on the argument")
             && Contract.assertEquals(maxCredit, Contract.oldIntValue(maxCredit)    
                  , "Max credit should not change");
    else
      return    Contract.assertEquals(Contract.intResult(), 0                              
                  , "Result should be 0")
             && Contract.assertEquals(balance, Contract.oldIntValue(balance)  
                  , "Balance should not change")
             && Contract.assertEquals(maxCredit, Contract.oldIntValue(maxCredit)
                  , "Max credit should not change");
  }
  
  public void transferUpdate(int sum)
  {
    if(possibleTransfer(sum) && checkedObject.getPermitter().isPermittedTransfer(checkedObject, sum))
      balance += sum;
  }
}
