/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 06.10.2009
 *
 */

package mbtest.tests.account;

import mbtest.coverage.Coverage;
import mbtest.tracing.Logger;

/**
 * @author Victor Kuliamin
 *
 */
public class AccountCoverage
{
  static Logger logger = new Logger(AccountCoverage.class);
  
  int balance;
  int maxCredit;

  Account checkedObject;
  
  public void setCheckedObject(Account checkedObject)
  {
    this.checkedObject = checkedObject;
    this.balance       = checkedObject.getBalance();
    this.maxCredit     = checkedObject.getMaxCredit();
  }
  
  public boolean possibleTransfer(int sum)
  {
    if(balance + sum > maxCredit) return true;
    else                          return false;
  }
  
  public void transferCoverage(int sum)
  {
    boolean permission = checkedObject.getPermitter().isPermittedTransfer(checkedObject, sum);
    
    if (possibleTransfer(sum)) Coverage.addDescriptor("Possible transfer");
    else                       Coverage.addDescriptor("Too big sum");
    
    if(permission)             Coverage.addDescriptor("Permitted");
    else                       Coverage.addDescriptor("Not permitted");
    
    if(balance == 0)           Coverage.addDescriptor("Zero balance");
    else if(balance > 0)       Coverage.addDescriptor("Positive balance");
    else                       Coverage.addDescriptor("Negative balance");
    
    if(sum == 0)               Coverage.addDescriptor("Zero sum");
    else if(sum > 0)           Coverage.addDescriptor("Positive sum");
    else                       Coverage.addDescriptor("Negative sum");
  }
  
  public void transferCoverageX(int sum)
  {
    boolean permission = checkedObject.getPermitter().isPermittedTransfer(checkedObject, sum);
    
    if (possibleTransfer(sum))
    {
      Coverage.addDescriptor("Possible transfer");
      if(permission)
      {
        Coverage.addDescriptor("Permitted");
        if(balance == 0)
        {
          Coverage.addDescriptor("Zero balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else if(balance > 0)
        {
          Coverage.addDescriptor("Positive balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else
        {
          Coverage.addDescriptor("Negative balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
      }
      else
      {
        Coverage.addDescriptor("Not permitted");
        if(balance == 0)
        {
          Coverage.addDescriptor("Zero balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else if(balance > 0)
        {
          Coverage.addDescriptor("Positive balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else
        {
          Coverage.addDescriptor("Negative balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
      }
    }
    else
    {
      Coverage.addDescriptor("Too big sum");
      if(permission)
      {
        Coverage.addDescriptor("Permitted");
        if(balance == 0)
        {
          Coverage.addDescriptor("Zero balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else if(balance > 0)
        {
          Coverage.addDescriptor("Positive balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else
        {
          Coverage.addDescriptor("Negative balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
      }
      else
      {
        Coverage.addDescriptor("Not permitted");
        if(balance == 0)
        {
          Coverage.addDescriptor("Zero balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else if(balance > 0)
        {
          Coverage.addDescriptor("Positive balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
        else
        {
          Coverage.addDescriptor("Negative balance");
          if(sum == 0)      Coverage.addDescriptor("Zero sum");
          else if(sum > 0)  Coverage.addDescriptor("Positive sum");
          else              Coverage.addDescriptor("Negative sum");
        }
      }
    }
  }
  
  public void transferUpdate(int sum)
  {
    if(possibleTransfer(sum) && checkedObject.getPermitter().isPermittedTransfer(checkedObject, sum))
      balance += sum;
  }

}
