/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 04.10.2009
 *
 */

package mbtest.tests.account;

import mbtest.tracing.Logger;

/**
 * @author Victor Kuliamin
 *
 */
public class AccountImpl implements Account
{
  static Logger logger = new Logger(AccountImpl.class);
  
  int balance = 0;
  int maxCredit = -5;
  AuditLog  log = new AuditLog();
  Permitter permitter;
  
  public int transfer(int sum)
  {
    boolean permission = permitter.isPermittedTransfer(this, sum);
    
    if(balance + sum > maxCredit && permission)
    {
      log.logKind("SUCCESS");
      log.logOldBalance(balance);

      //if(sum == 2 && balance == 18)
      //  balance++;
      balance += sum;

      log.logSum(sum);
      log.logNewBalance(balance);
      
   }
    else
    {
      if(!permission) log.logKind("BANNED");
      else            log.logKind("IMPROPER");
      
      log.logOldBalance(balance); 
      log.logSum(sum);
      sum = -1;//-1;
    }

    return sum;
  }

  public int getBalance()   { return balance; }
  public int getMaxCredit() { return maxCredit; }

  public AuditLog getLog() { return log; }
  public void setLog(AuditLog log) { this.log = log; }

  public Permitter getPermitter() { return permitter; }
  public void setPermitter(Permitter permitter) { this.permitter = permitter; }
}
