/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 12.03.2012
 *
 */

package mbtest.tests.account;

import org.springframework.context.ApplicationContext;

import mbtest.MBTester;
import mbtest.annotations.BeforeTest;
import mbtest.annotations.Test;
import mbtest.components.CTest;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class ErrorTest
{
  AccountTest test;
  
  public ErrorTest() {}
  
  @BeforeTest
  public void initFields()
  {
    ApplicationContext ctx = CTest.getCurrentTest().getAppContext();
    test = (AccountTest)ctx.getBean("accountTest");
  }
  
  @Test
  public void shortPath()
  {
    test.testDeposit(5);
    test.testDeposit(6);
    test.switchPermission();
    test.testWithdraw(6);
  }
  
  public static void main(String[] args)
  {
    MBTester.main(new String[]{
         "-loglevel"      , "info"
       , "-testclass"     , "mbtest.tests.account.ErrorTest"
       , "-explorer"      , "bfs"//"bfs"
       , "-conffile"      , "accountConfig.xml"
       , "-maxtransitions", "-1"
       , "-maxstates"     , "-1"
       , "-maxpath"       , "-1"
       , "-maxfails"      , "79"
       //, "-ignorefails"
      });

  }

}
