package mbtest.tests.config;

import mbtest.annotations.AfterMethod;
import mbtest.annotations.BeforeMethod;
import mbtest.annotations.BeforeSuite;
import mbtest.annotations.AfterSuite;
import mbtest.annotations.BeforeTest;
import mbtest.annotations.AfterTest;
import mbtest.annotations.BeforeClass;
import mbtest.annotations.AfterClass;
import mbtest.annotations.InState;

import mbtest.annotations.Test;
import mbtest.annotations.State;

import mbtest.annotations.AfterGroups;
import mbtest.annotations.BeforeGroups;


@Test
public class TestExample1
{
  int before_ab_counter = 0;
  int after_ab_counter = 0;
  
  int state = 0;
  
  @State
  public int getState()
  {
    return state;
  }
  
  @InState(firstTimeOnly = true)
  public void inStateOnce()
  {
    System.out.println("In state once TE1, nothing");
  }

  @InState
  public void inState()
  {
    System.out.println("In state TE1, nothing");
  }
  
  @BeforeSuite
  public void beforeSuite()
  {
    System.out.println("Before suite TE1, nothing");
  }
  
  @BeforeSuite(groups = "a")
  public void beforeSuiteA()
  {
    System.out.println("Before suite TE1, a");
  }

  @BeforeSuite(groups = "b")
  public void beforeSuiteB()
  {
    System.out.println("Before suite TE1, b");
  }
  
  @BeforeSuite(groups = {"a", "b"})
  public void beforeSuiteAB()
  {
    System.out.println("Before suite TE1, ab");
  }

  @BeforeTest
  public void beforeTest()
  {
    System.out.println("Before test TE1, nothing");
  }

  @BeforeTest(groups = "a")
  public void beforeTestA()
  {
    System.out.println("Before test TE1, a");
  }
  
  @BeforeTest(groups = "b")
  public void beforeTestB()
  {
    System.out.println("Before test TE1, b");
  }

  @BeforeTest(groups = {"a", "b"})
  public void beforeTestAB()
  {
    System.out.println("Before test TE1, ab");
  }
  
  @BeforeClass
  public void beforeClass()
  {
    System.out.println("Before class TE1, nothing");
  }

  @BeforeClass(groups = "a")
  public void beforeClassA()
  {
    System.out.println("Before class TE1, a");
  }
  
  @BeforeClass(groups = "b")
  public void beforeClassB()
  {
    System.out.println("Before class TE1, b");
  }

  @BeforeClass(groups = {"a", "b"})
  public void beforeClassAB()
  {
    System.out.println("Before class TE1, ab");
  }

  @BeforeGroups
  public void beforeGroup()
  {
    System.out.println("Before group TE1, nothing");
  }
  
  @BeforeGroups(groups = "a")
  public void beforeGroupA()
  {
    System.out.println("Before group TE1, a");
  }
  
  @BeforeGroups(groups = "b")
  public void beforeGroupB()
  {
    System.out.println("Before group TE1, b");
  }
  
  @BeforeGroups(groups = { "a", "b"})
  public void beforeGroupAB()
  {
    before_ab_counter++;
    System.out.println("Before group TE1, ab");
    System.out.println("XXX Before AB conuter = " + before_ab_counter);
  }
  
  @BeforeMethod
  public void beforeMethod()
  {
    System.out.println("Before method TE1, nothing");
  }
  
  @BeforeMethod(groups = "a", affectedGroups = "a")
  public void beforeMethodA()
  {
    System.out.println("Before method TE1, a AAAAA");
  }
  
  @BeforeMethod(groups = "b")
  public void beforeMethodB()
  {
    System.out.println("Before method TE1, b");
  }
  
  @BeforeMethod(groups = { "a", "b"})
  public void beforeMethodAB()
  {
    System.out.println("Before method TE1, ab");
  }
  
  @Test
  public void testN1()
  {
    System.out.println("TestN1 TE1, nothing");
    if(state <= 1) state++;
  }

  @Test
  public void testN2()
  {
    System.out.println("TestN2 TE1, nothing");
    if(state >= -1) state--;
  }
  
  @Test(groups = "a")
  public void testA1()
  {
    System.out.println("TestA1 TE1, a");
  }

  @Test(groups = "a")
  public void testA2()
  {
    System.out.println("TestA2 TE1, a");
  }
  
  @Test(groups = "b")
  public void testB1()
  {
    System.out.println("TestB1 TE1, b");
  }

  @Test(groups = "b")
  public void testB2()
  {
    System.out.println("TestB2 TE1, b");
  }
  
  @Test(groups = {"a", "b"})
  public void testAB1()
  {
    System.out.println("TestAB1 TE1, ab");
  }

  @Test(groups = {"a", "b"})
  public void testAB2()
  {
    System.out.println("TestAB2 TE1, ab");
  }
  
  @AfterMethod
  public void afterMethod()
  {
    System.out.println("After method TE1, nothing");
  }
  
  @AfterMethod(groups = "a")
  public void afterMethodA()
  {
    System.out.println("After method TE1, a");
  }
  
  @AfterMethod(groups = "b")
  public void afterMethodB()
  {
    System.out.println("After method TE1, b");
  }
  
  @AfterMethod(groups = { "a", "b"})
  public void afterMethodAB()
  {
    System.out.println("After method TE1, ab");
  }
  

  @AfterGroups
  public void afterGroup()
  {
    System.out.println("After group TE1, nothing");
  }
  
  @AfterGroups(groups = "a")
  public void afterGroupA()
  {
    System.out.println("After group TE1, a");
  }

  @AfterGroups(groups = "b")
  public void afterGroupB()
  {
    System.out.println("After group TE1, b");
  }

  @AfterGroups(groups = {"a", "b"})
  public void afterGroupAB()
  {
    after_ab_counter++;
    System.out.println("After group TE1, ab");
    System.out.println("XXX After AB conuter = " + after_ab_counter);
  }

  @AfterClass
  public void afterClass()
  {
    System.out.println("After class TE1, nothing");
  }
  
  @AfterClass(groups = "a")
  public void afterClassA()
  {
    System.out.println("After class TE1, a");
  }
  
  @AfterClass(groups = "b")
  public void afterClassB()
  {
    System.out.println("After class TE1, b");
  }

  @AfterClass(groups = {"a", "b"})
  public void afterClassAB()
  {
    System.out.println("After class TE1, ab");
  }

  @AfterTest
  public void afterTest()
  {
    System.out.println("After test TE1, nothing");
  }
  
  @AfterTest(groups = "a")
  public void afterTestA()
  {
    System.out.println("After test TE1, a");
  }
  
  @AfterTest(groups = "b")
  public void afterTestB()
  {
    System.out.println("After test TE1, b");
  }

  @AfterTest(groups = {"a", "b"})
  public void afterTestAB()
  {
    System.out.println("After test TE1, ab");
  }

  @AfterSuite
  public void afterSuite()
  {
    System.out.println("After suite TE1, nothing");
  }
  
  @AfterSuite(groups = "a")
  public void afterSuiteA()
  {
    System.out.println("After suite TE1, a");
  }

  @AfterSuite(groups = "b")
  public void afterSuiteB()
  {
    System.out.println("After suite TE1, b");
  }

  @AfterSuite(groups = {"a", "b"})
  public void afterSuiteAB()
  {
    System.out.println("After suite TE1, ab");
  }
}
