package mbtest.tests.config;

import mbtest.annotations.AfterClass;
import mbtest.annotations.AfterSuite;
import mbtest.annotations.AfterTest;
import mbtest.annotations.BeforeClass;
import mbtest.annotations.BeforeSuite;
import mbtest.annotations.BeforeTest;
import mbtest.annotations.Test;

import mbtest.annotations.AfterGroups;
import mbtest.annotations.BeforeGroups;

@Test
public class TestExample2
{
  int before_ab_counter = 0;
  int after_ab_counter = 0;

  @BeforeSuite
  public void beforeSuite()
  {
    System.out.println("Before suite TE2, nothing");
  }
  
  @BeforeSuite(groups = "a")
  public void beforeSuiteA()
  {
    System.out.println("Before suite TE2, a");
  }

  @BeforeSuite(groups = "b")
  public void beforeSuiteB()
  {
    System.out.println("Before suite TE2, b");
  }
  
  @BeforeSuite(groups = {"a", "b"})
  public void beforeSuiteAB()
  {
    System.out.println("Before suite TE2, ab");
  }

  @BeforeTest
  public void beforeTest()
  {
    System.out.println("Before test TE2, nothing");
  }

  @BeforeTest(groups = "a")
  public void beforeTestA()
  {
    System.out.println("Before test TE2, a");
  }
  
  @BeforeTest(groups = "b")
  public void beforeTestB()
  {
    System.out.println("Before test TE2, b");
  }

  @BeforeTest(groups = {"a", "b"})
  public void beforeTestAB()
  {
    System.out.println("Before test TE2, ab");
  }
  
  @BeforeClass
  public void beforeClass()
  {
    System.out.println("Before class TE2, nothing");
  }

  @BeforeClass(groups = "a")
  public void beforeClassA()
  {
    System.out.println("Before class TE2, a");
  }
  
  @BeforeClass(groups = "b")
  public void beforeClassB()
  {
    System.out.println("Before class TE2, b");
  }

  @BeforeClass(groups = {"a", "b"})
  public void beforeClassAB()
  {
    System.out.println("Before class TE2, ab");
  }

  @BeforeGroups
  public void beforeGroup()
  {
    System.out.println("Before group TE2, nothing");
  }
  
  @BeforeGroups(groups = "a")
  public void beforeGroupA()
  {
    System.out.println("Before group TE2, a");
  }
  
  @BeforeGroups(groups = "b")
  public void beforeGroupB()
  {
    System.out.println("Before group TE2, b");
  }
  
  @BeforeGroups(groups = { "a", "b"})
  public void beforeGroupAB()
  {
    before_ab_counter++;
    System.out.println("Before group TE2, ab");
    System.out.println("XXX Before AB counter = " + before_ab_counter);
  }
  
  @Test
  public void testN1()
  {
    System.out.println("TestN1 TE2, nothing");
  }

  @Test
  public void testN2()
  {
    System.out.println("TestN2 TE2, nothing");
  }
  
  @Test(groups = "a")
  public void testA1()
  {
    System.out.println("TestA1 TE2, a");
  }

  @Test(groups = "a")
  public void testA2()
  {
    System.out.println("TestA2 TE2, a");
  }
  
  @Test(groups = "b")
  public void testB1()
  {
    System.out.println("TestB1 TE2, b");
  }

  @Test(groups = "b")
  public void testB2()
  {
    System.out.println("TestB2 TE2, b");
  }
  
  @Test(groups = {"a", "b"})
  public void testAB1()
  {
    System.out.println("TestAB1 TE2, ab");
  }

  @Test(groups = {"a", "b"})
  public void testAB2()
  {
    System.out.println("TestAB2 TE2, ab");
  }

  @AfterGroups
  public void afterGroup()
  {
    System.out.println("After group TE2, nothing");
  }
  
  @AfterGroups(groups = "a")
  public void afterGroupA()
  {
    System.out.println("After group TE2, a");
  }

  @AfterGroups(groups = "b")
  public void afterGroupB()
  {
    System.out.println("After group TE2, b");
  }

  @AfterGroups(groups = {"a", "b"})
  public void afterGroupAB()
  {
    after_ab_counter ++;
    System.out.println("After group TE2, ab");
    System.out.println("XXX After AB counter = " + after_ab_counter);
  }

  @AfterClass
  public void afterClass()
  {
    System.out.println("After class TE2, nothing");
  }
  
  @AfterClass(groups = "a")
  public void afterClassA()
  {
    System.out.println("After class TE2, a");
  }
  
  @AfterClass(groups = "b")
  public void afterClassB()
  {
    System.out.println("After class TE2, b");
  }

  @AfterClass(groups = {"a", "b"})
  public void afterClassAB()
  {
    System.out.println("After class TE2, ab");
  }

  @AfterTest
  public void afterTest()
  {
    System.out.println("After test TE2, nothing");
  }
  
  @AfterTest(groups = "a")
  public void afterTestA()
  {
    System.out.println("After test TE2, a");
  }
  
  @AfterTest(groups = "b")
  public void afterTestB()
  {
    System.out.println("After test TE2, b");
  }

  @AfterTest(groups = {"a", "b"})
  public void afterTestAB()
  {
    System.out.println("After test TE2, ab");
  }

  @AfterSuite
  public void afterSuite()
  {
    System.out.println("After suite TE2, nothing");
  }
  
  @AfterSuite(groups = "a")
  public void afterSuiteA()
  {
    System.out.println("After suite TE2, a");
  }

  @AfterSuite(groups = "b")
  public void afterSuiteB()
  {
    System.out.println("After suite TE2, b");
  }

  @AfterSuite(groups = {"a", "b"})
  public void afterSuiteAB()
  {
    System.out.println("After suite TE2, ab");
  }

}
