package mbtest.tests.config;

import mbtest.annotations.AfterMethod;
import mbtest.annotations.BeforeMethod;
import mbtest.annotations.Test;

@Test
public class TestExample3
{
  @Test(dependsOnGroups = "A")
  public void test()
  {
    System.out.println("Test");
  }

  @Test(groups = "C", dependsOnGroups = "B")
  public void testC()
  {
    System.out.println("TestC");
  }
  
  @Test(groups = {"A", "C"}, dependsOnMethods = "testAB()")
  public void testAC()
  {
    System.out.println("TestAC");
  }
  
  @Test(groups = {"B", "C"}, dependsOnMethods = "testB()")
  public void testBC()
  {
    System.out.println("TestBC");
  }
  
  @Test(groups = "A", dependsOnMethods = {"testAB()"})
  public void testA()
  {
    System.out.println("TestA");
  }

  @Test(groups = "B", dependsOnMethods = {"test()"})
  public void testB()
  {
    System.out.println("TestB");
  }

  @Test(groups = {"A", "B"})
  public void testAB()
  {
    System.out.println("TestAB");
  }
  
  @BeforeMethod
  public void before()
  {
    System.out.println("Before");
  }

  @BeforeMethod(affectedGroups= "A")
  public void beforeA()
  {
    System.out.println("BeforeA");
  }

  @BeforeMethod(affectedGroups = "B")
  public void beforeB()
  {
    System.out.println("BeforeB");
  }

  @AfterMethod
  public void after()
  {
    System.out.println("After");
  }

  @AfterMethod(affectedGroups= "A")
  public void afterA()
  {
    System.out.println("AfterA");
  }

  @AfterMethod(affectedGroups = "B")
  public void afterB()
  {
    System.out.println("AfterB");
  }
}
