/*
 * Copyright (c) 2008 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 01.10.2008.
 *
 */

package mbtest.tests.exploration;

import mbtest.exploration.StateMachine;

/**
 * @author   Victor Kuliamin
 * @version  0.1
 *
 */
public class FSMImpl2 extends StateMachine
{
  public static class Transition extends StateMachine.Transition
  {
    int number;
    
    public Transition(int number)
    {
      this.number = number;
    }
    
    public String toString()
    {
      return "" + number;
    }
  }
  
  int state = 0;
  
  int maxState;
  int mainTrans;
  int addTrans;
  
  public Object getState()
  {
    return new Integer(state);
  }
  
  public FSMImpl2(int maxState, int mainTrans, int addTrans)
  {
    this.maxState  = maxState;
    this.mainTrans = mainTrans;
    this.addTrans  = addTrans;
  }
  
  public FSMImpl2 clone()
  {
    FSMImpl2 res = new FSMImpl2(maxState, mainTrans, addTrans);
    res.state = this.state;
    
    return res;
  }
  
  public StateMachine.Transition getNextTransition(Object st, StateMachine.Transition r)
  {
    if(r == null) return new Transition(0);
      
    Transition t = (Transition)r;
    
    if(t.number < mainTrans || state < addTrans && t.number == mainTrans)
      return new Transition(t.number+1);
    else
      return null;
  }
  
  public void executeTransition(StateMachine.Transition r)
  {
    Transition t = (Transition)r;
    
    if(t.number <= mainTrans)
      state = (state + t.number)%maxState;
    else
      state = (state + maxState/2 + 1)%maxState;
  }

  @Override
  public void enterState(Object state, boolean isNew)
  {
    // TODO Auto-generated method stub
    
  }

}
