/*
 * Copyright (c) 2008 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 08.10.2008.
 *
 */

package mbtest.tests.exploration;

import mbtest.exploration.StateMachine;

/**
 * @author   Victor Kuliamin
 * @version  0.1
 *
 */
public class FSMImpl3 extends StateMachine
{
  public static class Transition extends StateMachine.Transition
  {
    int number;
    
    public Transition(int number)
    {
      this.number = number;
    }
    
    public String toString()
    {
      return "" + number;
    }
  }
  
  int state = 0;
  
  int maxPathLength;
  
  public Object getState()
  {
    return new Integer(state);
  }
  
  public FSMImpl3(int maxPathLength)
  {
    this.maxPathLength = maxPathLength;
  }
  
  public StateMachine.Transition getNextTransition(Object st, StateMachine.Transition r)
  {
    if(r == null) return new Transition(0);
      
    Transition t = (Transition)r;
    
    if(t.number < 1) return new Transition(t.number+1);
    else             return null;
  }
  
  
  public void executeTransition(StateMachine.Transition r)
  {
    Transition t = (Transition)r;
    
    switch(t.number)
    {
       case 0:
         if(state == maxPathLength || state == 2*maxPathLength-1)
           state--;
         else
           state++;
         break;
       case 1:
         if(state == 0) 
           state = maxPathLength+1;
         else if(state == maxPathLength+1) 
           state++;
         else if(state == 2*maxPathLength-1)
           state = maxPathLength;
         else
           state--;
         break;
       default:
         break;
    }
  }

  /* (non-Javadoc)
   * @see mbtest.exploration.StateMachine#enterState(java.lang.Object, boolean)
   */
  @Override
  public void enterState(Object state, boolean isNew)
  {
    // TODO Auto-generated method stub

  }

}
