/*
 * Copyright (c) 2008 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 08.10.2008.
 *
 */

package mbtest.tests.exploration;

import mbtest.exploration.StateMachine;

/**
 * @author   Victor Kuliamin
 * @version  0.1
 *
 */
public class FSMImpl4 extends StateMachine
{
  public static class Transition extends StateMachine.Transition
  {
    int number;
    
    public Transition(int number)
    {
      this.number = number;
    }
    
    public String toString()
    {
      return "" + number;
    }
  }
  
  int state = 0;
  
  int maxState;
  int maxTrans;
  
  public Object getState()
  {
    return new Integer(state);
  }
  
  public FSMImpl4(int maxState, int maxTrans)
  {
    this.maxState = maxState;
    this.maxTrans = maxTrans;
  }
  
  public StateMachine.Transition getNextTransition(Object st, StateMachine.Transition r)
  {
    if(r == null) return new Transition(0);
      
    Transition t = (Transition)r;
    
    if(t.number < maxTrans) return new Transition(t.number+1);
    else                    return null;
  }
  
  
  public void executeTransition(StateMachine.Transition r)
  {
    Transition t = (Transition)r;
    
    switch(t.number)
    {
       case 0:
         if(state > 0) state --;
         break;
       case 1:
         if(state < maxState) state++; 
         break;
       default:
         if(state >= t.number) state -= t.number;
         break;
    }
  }

  /* (non-Javadoc)
   * @see mbtest.exploration.StateMachine#enterState(java.lang.Object, boolean)
   */
  @Override
  public void enterState(Object state, boolean isNew)
  {
    // TODO Auto-generated method stub

  }
}
