/*
 * Copyright (c) 2008 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 09.10.2008.
 *
 */

package mbtest.tests.exploration;

import mbtest.exploration.StateMachine;

/**
 * @author   Victor Kuliamin
 * @version  0.1
 *
 */
public class FSMND extends StateMachine
{
  public static class Transition extends StateMachine.Transition
  {
    int number;
    
    public Transition(int number)
    {
      this.number = number;
    }
    
    public String toString()
    {
      return "" + number;
    }
  }
  
  int state = 0;
  int count = 0;
  
  int maxState;
  int maxTrans;
  
  public Object getState()
  {
    return new Integer(state);
  }
  
  public FSMND(int maxState, int maxTrans)
  {
    this.maxState = maxState;
    this.maxTrans = maxTrans;
  }
  
  public StateMachine.Transition getNextTransition(Object st, StateMachine.Transition r)
  {
    if(r == null) return new Transition(0);
      
    Transition t = (Transition)r;
    
    if(t.number < Math.max(3, maxTrans)) return new Transition(t.number+1);
    else                                 return null;
  }
  
  
  public void executeTransition(StateMachine.Transition r)
  {
    Transition t = (Transition)r;
    
    switch(t.number)
    {
       case 0: break;
       case 1:
         if(state < maxState && (state != maxState-2 || state == maxState-2 && count == 0))
         {
           if(state == maxState-2) count++;
           state++;
         }
         else if(state == maxState-2 && count > 0 )
           state--;
         break;
       case 2:
         if(state%2 == 0 && state < maxState) state++;
         else if(state%2 != 0)                state--;
         break;
       case 3:
         if(state < 3)
         {
           if(state < maxState) state++;
           else                 state = 0;
         }
         else if(state%2 == 0 && state < maxState) state++;
         else                                      state -= 3;
         break;
       default:
         if(state > t.number) state -= t.number;
         break;
    }
  }

  @Override
  public void enterState(Object state, boolean isNew)
  {
    // TODO Auto-generated method stub
    
  }
}
