/*
 * Copyright (c) 2008 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 10.10.2008.
 *
 */

package mbtest.tests.exploration;

import java.util.BitSet;
import java.util.Random;

import mbtest.exploration.StateMachine;

/**
 * @author   Victor Kuliamin
 * @version  0.1
 *
 */
public class NDCubeFSM extends StateMachine
{
  public static class Transition extends StateMachine.Transition
  {
    int number;
    
    public Transition(int number)
    {
      this.number = number;
    }
    
    public String toString()
    {
      return "" + number;
    }
  }
  
  BitSet state = new BitSet();
  Random rand  = new Random(System.currentTimeMillis()); 
  
  int n;
  
  public Object getState()
  {
    return state.clone();
  }
  
  public NDCubeFSM(int n)
  {
    this.n = n;
  }
  
  public StateMachine.Transition getNextTransition(Object st, StateMachine.Transition r)
  {
    if(r == null) return new Transition(0);
      
    Transition t = (Transition)r;
    
    if(t.number < n) return new Transition(t.number+1);
    else             return null;
  }
  
  
  public void executeTransition(StateMachine.Transition r)
  {
    Transition t = (Transition)r;
    int i = t.number, b, c = state.cardinality(), j = 0, count = 0;
    
    if(i == n) return;
    
    if(state.get(i))
    {
      if(c == 1) state.flip(i);
      else
      {
        b = rand.nextInt(c);
        while(count < b && j < n) 
        { 
          if(state.get(j)) count++;
          j++;
        }
        while(!state.get(j) && j < n) j++;
        state.flip(j);
      }
    }
    else state.flip(i);
  }

  @Override
  public void enterState(Object state, boolean isNew)
  {
    // TODO Auto-generated method stub
    
  }
}
