/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 04.04.2001
 * 
 */
package mbtest.tests.guide.intset;

//import java.util.IdentityHashMap;
//import java.util.Iterator;

/**
 * A set of int values.
 * 
 * @author Victor Kuliamin
 */
public class IntSet //implements Iterable<Integer>
{
  protected IntSetNode _node = null;
  protected int _size = 0;
  
  public IntSet() {}
  
  public synchronized int size()
  {
    return _size;
  }

  public synchronized boolean add(int value)
  {
    if(_node == null)
    {
      _node = new IntSetNode(value);
      _node._red = false;
      _size++;
      
      return true;
    }
    
    IntSetNode p = _node, q;
    
    do
    {
      q = p;
      
      if(p._value == value)
        return false;
      else if(p._value > value)
        p = p._left;
      else
        p = p._right;
    }
    while(p != null);
    
    if(q._value > value)
      q._left = ( p =  new IntSetNode(value) );
    else
      q._right = ( p = new IntSetNode(value) );
    p._parent = q;
    
    _size++;
    
    IntSetNode r;
    
    while(q != null && q._red == true)
    {
      if(q == q._parent._left)
      {
        r = q._parent._right;
        if(r == null || !r._red )
        {
          if(p == q._right)
          {
            q._right = p._left;
            if(p._left != null) p._left._parent = q;
            p._left = q;
            p._parent = q._parent;
            q._parent._left = p;
            q._parent = p;
            p = q;
            q = q._parent;
          }
          
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent)
              q._parent._parent._left = q;
            else
              q._parent._parent._right = q;
          }
          else
            _node = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._left = q._right;
          if(q._right != null) q._right._parent = q._parent;
          q._right = q._parent;
          q._parent = q._parent._parent;
          q._right._parent = q;
          
          return true;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
      else
      {
        r = q._parent._left;
        if(r == null || !r._red)
        {
          if(p == q._left)
          {
            q._left = p._right;
            if(p._right != null) p._right._parent = q;
            p._right = q;
            p._parent = q._parent;
            q._parent._right = p;
            q._parent = p;
            p = q;
            q = q._parent;
          }
          
         if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent)
              q._parent._parent._left = q;
            else
              q._parent._parent._right = q;
          }
          else
            _node = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._right = q._left;
          if(q._left != null) q._left._parent = q._parent;
          q._left = q._parent;
          q._parent = q._parent._parent;
          q._left._parent = q;
          
          return true;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
    }
    
    _node._red = false;
    
    return true;
  }

  public synchronized boolean contains(int value)
  {
    if(_node == null)
      return false;
    
    IntSetNode p = _node;
    
    do
    {
      if(p._value == value)
        return true;
      else if(p._value > value)
        p = p._left;
      else
        p = p._right;
    }
    while(p != null);
    
    return false;
  }

  public synchronized boolean remove(int value)
  {
    if(_node == null)
      return false;
    
    IntSetNode p = _node;
    
    do
    {
      if(p._value > value)
        p = p._left;
      else if(p._value < value)
        p = p._right;
      else
        break;
    }
    while(p != null);
    
    if(p == null)
      return false;
    
    boolean isLeft;
    
    if(p._left == null)
    {
      if(p._parent == null)
      {
        _node = p._right;
        isLeft = true;
      }
      else
      {
        if(p == p._parent._left)
        {
          p._parent._left = p._right;
          isLeft = true;
        }
        else
        {
          p._parent._right = p._right;
          isLeft = false;
        }
      }
      
      if(p._right != null)
        p._right._parent = p._parent;
      
      if(!p._red)
        fixup(p._parent, p._right, isLeft);
    }
    else if(p._right == null)
    {
      if(p._parent == null)
      {
        _node = p._left;
        isLeft = true;
      }
      else
      {
        if(p == p._parent._left)
        {
          p._parent._left = p._left;
          isLeft = true;
        }
        else
        {
          p._parent._right = p._left;
          isLeft = false;
        }
      }
      
      p._left._parent = p._parent;
      if(!p._red)
        fixup(p._parent, p._left, isLeft);
    }
    else
    {
      IntSetNode q = next(p);
      p._value = q._value;
      
      if(q._parent == null)
      {
        _node = q._right;
        isLeft = true;
      }
      else
      {
        if(q == q._parent._left)
        {
          q._parent._left = q._right;
          isLeft = true;
        }
        else
        {
          q._parent._right = q._right;
          isLeft = false;
        }
      }
      
      if(q._right != null)
        q._right._parent = q._parent;
      
      if(!q._red)
        fixup(q._parent, q._right, isLeft); 
    }
    
    _size--;
    return true;
  }
  
  //-----------------------------------------------------------------
  // auxiliary methods
  //
  protected IntSetNode next(IntSetNode p)
  {
    if(p._right != null) return p._right.minimum();
    
    while(p._parent != null && p == p._parent._right)
      p = p._parent;

    return p._parent;
  }
  
  protected void fixup(IntSetNode p, IntSetNode q, boolean isLeft)
  {
    while(p != null && (q == null || q._red == false))
    {
      IntSetNode w, v;
      
      if(isLeft)
      {
        w = p._right;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(true, p);
          w = p._right;
        }
        
        v = w._left;
        
        if(w._right == null || !w._right._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            
            q = p;
            p = p._parent;
            
            if(p == null)
              isLeft = true;
            else
              isLeft = (q == p._left);
            //isLeft = (p == null)?true:(q == p._left);
            
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(false, w);
            
            w = v;
            v = v._left;
          }
        }
        
        w._red = p._red;
        p._red = false;
        
        if(w._right != null)
          w._right._red = false;
          
        rotate(true, p);
        
        q = _node;
        p = null;
      }
      else
      {
        w = p._left;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(false, p);
          w = p._left;
        }
        
        v = w._right;
        
        if(w._left == null || !w._left._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            
            q = p;
            p = p._parent;
            
            if(p == null)
              isLeft = true;
            else
              isLeft = (q == p._left);
            //isLeft = (p == null)?true:(q == p._left);
            
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(true, w);
            
            w = v;
            v = v._right;
          }
        }
        
        w._red = p._red;
        p._red = false;
        
        if(w._left != null)
          w._left._red = false;
          
        rotate(false, p);
        
        q = _node;
        p = null;
      }
    }
    
    if(q != null)
      q._red = false;
  }
  
  protected void rotate(boolean left, IntSetNode x)
  {
    IntSetNode y;
    
    if(left)
    {
      y = x._right;
      x._right = y._left;
      if(y._left != null)
        y._left._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left)
          x._parent._left = y;
        else
          x._parent._right = y;
      }
      else
        _node = y;
      
      y._left = x;
      x._parent = y;
    }
    else
    {
      y = x._left;
      x._left = y._right;
      if(y._right != null)
        y._right._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left)
          x._parent._left = y;
        else
          x._parent._right = y;
      }
      else
        _node = y;
      
      y._right = x;
      x._parent = y;
    }
  }
  
  private static class IntSetNode
  {
    IntSetNode _left = null;
    IntSetNode _right = null;
    IntSetNode _parent = null;
    int _value = 0;
    boolean _red = true;
    
    IntSetNode(int value)
    {
      _value = value;
    }
    
    IntSetNode minimum()
    {
      IntSetNode p = this;
      
      while(p._left != null)
        p = p._left;
      
      return p;
    }
  }
}

