/**
 * Copyright (c) 2008 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 09.05.2013.
 *
 */
package mbtest.tests.guide.intset;

import mbtest.annotations.DataProvider;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class IntSetContractTest
{
  IntSet set;

  int n;
  public int[] values;
  
  public IntSetContractTest() { this(6); }
  
  public IntSetContractTest(int n)
  {
    this.n = n;
    values = new int[n];
    
    for(int i = 0; i < n; i++)
    {
      values[i] = ((i&1) != 0)?((i+1)/2):(-i/2);
    }
  }
  
  //@State
  //public int state() { return model.size(); }
  
  @State
  @DataProvider(name = "values")
  public boolean in(int i)
  {
    return set.contains(i);
  }

  @Test
  public void size()
  {
    set.size(); 
  }
  
  @Test(dependsOnMethods="size")
  @DataProvider(name = "values")
  public void contains(int i)
  {
    set.contains(i);
  }
  
  @Test(dependsOnMethods="remove")
  @DataProvider(name = "values")
  public void add(int i)
  {
    set.add(i);
  }

  @Test(dependsOnMethods="contains")
  @DataProvider(name = "values")
  public void remove(int i)
  {
    set.remove(i);
  }

  /**
   * @return the set
   */
  public IntSet getSet()
  {
    return set;
  }

  /**
   * @param set the set to set
   */
  public void setSet(IntSet set)
  {
    this.set = set;
  }

}
