/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 24.04.2012
 *
 */

package mbtest.tests.guide.intset;

import java.util.HashSet;

import mbtest.annotations.DataProvider;
import mbtest.annotations.State;
import mbtest.annotations.Test;
import mbtest.contracts.Contract;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class IntSetTest
{
  IntSet s = new IntSet();

  HashSet<Integer> model = new HashSet<Integer>();  

  int n;
  public int[] values;
  
  public IntSetTest() { this(3); }
  
  public IntSetTest(int n)
  {
    this.n = n;
    values = new int[n];
    
    for(int i = 0; i < n; i++)
    {
      values[i] = ((i&1) != 0)?((i+1)/2):(-i/2);
    }
  }
  
  //@State
  //public int state() { return model.size(); }
  
  @State
  @DataProvider(name = "values")
  public boolean in(int i)
  {
    return model.contains(i);
  }

  @Test
  public void size()
  {
    Contract.assertEquals(s.size(), model.size(), "size() result should coincide with model");
  }
  
  @Test(dependsOnMethods="size")
  @DataProvider(name = "values")
  public void contains(int i)
  {
    Contract.assertEquals(s.contains(i), model.contains(i), "contains() result should coincide with model");
  }
  
  @Test(dependsOnMethods="remove")
  @DataProvider(name = "values")
  public void add(int i)
  {
    Contract.assertEquals(s.add(i), model.add(i), "add() result should coincide with model");
  }

  @Test(dependsOnMethods="contains")
  @DataProvider(name = "values")
  public void remove(int i)
  {
    Contract.assertEquals(s.remove(i), model.remove(i), "remove() result should coincide with model");
  }
}
