/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on Oct 25, 2012
 *
 */

package mbtest.tests.guide.sqrt;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Test;
import mbtest.contracts.Contract;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class PVSqrtTest
{
  @Test
  @DataProvider(name="params")
  public void testAny(double x, double v)
  {
    Contract.assertEquals(Math.sqrt(x), v, "Square root of " + x + " should be equal to " + v);
  }
  
  Object[][] params = new Object[][]{  {0., 0.}, {1., 1.}, {4., 2.}, {9., 3.}, {16., 4.}
                                     , {25., 5.}, {100., 10.}, {169., 13.}, {225., 15.}, {289., 17.}
                                     , {2, 1.41421356237309505}, {3., 1.7320508075688773}
                                    };
}
