/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 30.09.2009
 *
 */
package mbtest.tests.maccount;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */

@Test
public class AccountTest
{
  Account account;
  boolean permission = true;
  
  public void setAccount(Account account)       
  { 
    this.account = account;
  }

  @State
  public int getBalance() { return account.getBalance(); }
  
  @Test
  @DataProvider(name = "sumArray")
  @Guard(names = "bound")
  public void testDeposit(int x)
  {
    account.deposit(x);
  }

  @Test
  @DataProvider(name = "sumArray")
  public void testWithdraw(int x)
  {
    account.withdraw(x);
  }
  
  public boolean bound()
  {
    return getBalance() <= 30;
  }
  
  public int[] sumArray = new int[]{0, 1, 2, 5};
}


