/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 21.02.2011
 *
 */

package mbtest.tests.testclass;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class ConfigurableSmallGraph
{
  int state = 0;
  
  @State
  public int getState() { return state; }
  
  @Test
  @Guard(names={"moveguard"})
  public void move(@DataProvider(name="data")int t, @DataProvider(name="data")int n) { state = t; }
  
  boolean moveguard(int t, int n) { return t < trans.length && n < trans[state][t]; }
  
  int[][] trans = new int[][]{
      {0, 9, 0, 0, 0, 7, 0, 0, 0, 8, 0, 0, 0, 0, 0}
     ,{0, 0, 5, 0, 9, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0}
     ,{0, 0, 0, 9, 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0}
     ,{0, 0, 0, 0, 2, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0}
     ,{0, 0, 0, 8, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0}
     ,{0, 0, 0, 0, 7, 0, 9, 0, 0, 9, 0, 7, 0, 0, 0}
     ,{0, 0, 0, 8, 0, 6, 0, 7, 0, 0, 6, 0, 0, 0, 0}
     ,{0, 0, 0, 0, 7, 0, 6, 0, 5, 0, 0, 0, 0, 0, 0}
     ,{0, 0, 0, 3, 0, 9, 0, 9, 0, 8, 0, 0, 0, 0, 0}
     ,{0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0}
     ,{9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0}
     ,{0, 0, 8, 0, 3, 0, 8, 0, 5, 0, 0, 0, 3, 0, 0}
     ,{9, 7, 3, 0, 9, 5, 9, 0, 9, 0, 0, 0, 0, 9, 0}
     ,{0, 9, 8, 0, 9, 0, 0, 7, 9, 0, 0, 0, 0, 0, 9}
     ,{8, 5, 9, 3, 6, 7, 9, 0, 9, 9, 9, 9, 9, 4, 0}
  };
//   {0, 1, 0, 0, 0, 0, 0, 0, 0, 0}
//  ,{0, 0, 1, 0, 0, 0, 0, 0, 0, 0}
//  ,{0, 0, 0, 1, 0, 0, 0, 0, 0, 0}
//  ,{0, 0, 0, 0, 1, 0, 1, 1, 1, 0}
//  ,{0, 0, 0, 0, 0, 1, 0, 0, 0, 0}
//  ,{0, 0, 1, 0, 0, 0, 0, 0, 0, 0}
//  ,{0, 1, 0, 0, 0, 0, 0, 0, 0, 0}
//  ,{0, 0, 0, 0, 0, 0, 0, 0, 1, 0}
//  ,{0, 0, 0, 0, 0, 0, 0, 1, 0, 0}
//  ,{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
  
  
  int N = 100;
  int[] data = new int[N];
  {
    for(int i = 0; i < N; i++) data[i] = i;//N-i-1;
  }
  
  
}
