/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 20.09.2011
 *
 */

package mbtest.tests.testclass;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;
import mbtest.util.Utils;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class ListTest
{
  public void print() 
  {
    System.out.println("YYY : maxValue = " +maxValue + ", maxLength = " + maxLength);
  }
  
  //protected int getMaxValue() { return 3; }
  protected int maxValue  = 2;
  protected int maxLength = 2;
  
  public ListTest() 
  {
    //System.out.println("XXX : maxValue = " + maxValue + ", maxLength = " + maxLength);
    
    values = new long[maxValue]; 
    for(int i = 0; i < maxValue; i++) values[i] = i;
  }
  
  public ListTest(int maxValue, int maxLength) 
  {
    //System.out.println("XXX : maxValue = " + maxValue + ", maxLength = " + maxLength);
    
    this.maxValue  = maxValue;
    this.maxLength = maxLength;
    
    values = new long[maxValue]; 
    for(int i = 0; i < maxValue; i++) values[i] = i;
  }

  
  List<Long> list = new ArrayList<Long>();
  
  @SuppressWarnings("unchecked")
  @State
  public List<Long> getList() { return (List<Long>)((ArrayList<Long>)list).clone(); }
  
  boolean sizeBound() { return list.size() < maxLength; }//7; }
  boolean argBound(long n) { return (n & 1) == 1 || !list.contains(n); }
  
  long[] values;// = new long[getMaxValue()]; //,1,2,3,4,5,6,7};//,3,4,5,6,7};
  //{
  //  for(int i = 0; i < getMaxValue(); i++) values[i] = i;
  //}
  
  public Iterator<Integer> indexIterator()
  {
    int n = list.size();
    int[] indices = new int[n];
    for(int i = 0; i < n; i++) indices[i] = i;
    
    return (Utils.ArrayToTypedList(indices)).iterator();
  }
  
  @Test//(dependsOnMethods = "removeByIndex")
  @DataProvider(name = "values")
  @Guard(names = {"sizeBound"})//, "argBound"})
  public void addLast(long n)
  {
    //if(n == 1 || n == 3) list.remove(n);
    //if(list.contains(0L)) throw new RuntimeException("Adding to 0!!!");
    list.add(n);
  }
  
  @Test(dependsOnMethods = "addLast")
  @DataProvider(name = "indexIterator")
  public void removeByIndex(int n)
  {
    //if(list.contains(0L)) throw new RuntimeException("Removing from 0!!!");
    list.remove(n);
  }

}
