/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 17.01.2012
 *
 */

package mbtest.tests.testclass;

import mbtest.annotations.DataProvider;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class MPMapState
{
  public int[] keys   = new int[]{0, 1, 2};
  public int[] keys2  = new int[]{0, 1};
  public int[][] values = new int[][]{{0, 0}, {0, 0}, {0,0}};
  
  int max = 2;
  
  public MPMapState(int max)
  {
    this.max = max;
  }
  
  @Test
  public void test(@DataProvider(name = "keys") int i, @DataProvider(name = "keys2") int j)
  {
    if(values[i][j] < max) values[i][j]++;
    else                   values[i][j] = 0;
  }
  
  @State//(defaultValue="1")
  public int value(@DataProvider(name = "keys") int i, @DataProvider(name = "keys2") int j)
  {
    return values[i][j];
  }

}
