/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 30.09.2011
 *
 */

package mbtest.tests.testclass;

import java.util.HashSet;
import java.util.Set;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class SetTest
{
  protected int maxValue = 10;
  protected int maxSize  = 10;
  
  Set<Long> set = new HashSet<Long>();
  
  @SuppressWarnings("unchecked")
  @State
  public Set<Long> getState() { return (Set<Long>)((HashSet<Long>)set).clone(); }
  
  boolean sizeBound() { return set.size() < maxSize; } 
  boolean addGuard(long n) { return !set.contains(n); }
  boolean remGuard(long n) { return set.contains(n); }
  
  long[] values = new long[maxValue]; 
  {
    for(int i = 0; i < maxValue; i++) values[i] = i;
  }
  
  @Test//(dependsOnMethods = "removeByIndex")
  @DataProvider(name = "values")
  @Guard(names = {"sizeBound", "addGuard"})
  public void add(long n)
  {
    //if(n == 1 || n == 3) list.remove(n);
    set.add(n);
  }
  
  @Test(dependsOnMethods = "add")
  @DataProvider(name = "values")
  @Guard(names = {"remGuard"})
  public void remove(long n)
  {
    set.remove(n);
  }

}
