/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 18.01.2012
 *
 */

package mbtest.tests.testclass;

import mbtest.annotations.DataProvider;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class SimpleMapState
{
  public int[] keys;
  public int[] values;
  
  public int maxValue = 2;
  
  public SimpleMapState()
  {
    this(2, 3);  
  }
  
  public SimpleMapState(int maxValue, int maxKey)
  {
    this.maxValue = maxValue;
    keys   = new int[maxKey];
    values = new int[maxKey];
    
    for(int i = 0; i < maxKey; i++)
    {
      keys[i]   = i;
      values[i] = 0;
    }
  }
  
  @Test
  @DataProvider(name = "keys")
  public void test( int i )
  {
    if(values[i] < maxValue) values[i]++;
    else                     values[i] = 0;
  }
  
  @State(defaultValue="-1")
  @DataProvider(name = "keys")
  public int value( int i )
  {
    return values[i];
  }

}
