/**
 * Copyright (c) 2009 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 16.02.2011
 *
 */

package mbtest.tests.testclass;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author Victor Kuliamin
 *
 */
@Test
public class Test1
{
  private int m = 0;
  
  @State
  public int state() { return m; }
  
  @Test
  @Guard(names={"upperBound","upperBound2"})
  public void test1(@DataProvider(name="data")int k, @DataProvider(name="data")int l) { m += Math.abs(k-l)+1; }
  
  @Test(dependsOnMethods="test1")
  @Guard(names="lowerBound")
  public void test2() { m--; }
  
  int[] data = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
  
  public boolean upperBound() { return m < 50; }
  public boolean lowerBound() { return m > -50; }
  //public boolean upperBound1(int k) { return (m < 5) && ((k&1) == 0); }
  public boolean upperBound2(int k, int l) { return (((k-l)%3) == 0); }
}
