/**
 * Copyright (c) 2008 ISP RAS.
 * 109004, A. Solzhenitsina, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id$
 * Created on 20.02.2011.
 *
 */
package mbtest.tests.testclass;

import mbtest.annotations.DataProvider;
import mbtest.annotations.Guard;
import mbtest.annotations.State;
import mbtest.annotations.Test;

/**
 * @author kuliamin
 *
 */
@Test
public class TwoStates
{
  int state = 0;
  
  @State
  public int getState() { return state; }
  
  @Test
  @Guard(names={"initial","uppar"})
  @DataProvider(name="data")
  public void up(int n) { state++; }
  
  @Test
  @Guard(names={"second","downpar"})
  @DataProvider(name="data")
  public void down(int n) { state--; }
  
  @Test
  @Guard(names={"initial","l1par"})
  @DataProvider(name="data")
  public void loop1(int n) {}

  @Test
  @Guard(names={"second","l2par"})
  @DataProvider(name="data")
  public void loop2(int n) {}
  
  boolean initial() { return state == 0; }
  boolean second() { return state == 1; }
  
  int N_UP   = 1;
  int N_DOWN = 2;
  int N_L1   = 2;
  int N_L2   = 2; 
  
  boolean uppar(int n)   { return n < N_UP;}
  boolean downpar(int n) { return n < N_DOWN;}
  boolean l1par(int n)   { return n < N_L1;}
  boolean l2par(int n)   { return n < N_L2;}
  
  
  int N = 100;
  int[] data = new int[N];
  {
    for(int i = 0; i < N; i++) data[i] = i;
  }
  
}
